<?php

namespace edu\wisc\doit;

/**
 * TODO: Write documentation
 */
interface UserDetailsProvider
{
    
    // Constants representing UW Federated login Shibboleth headers
    const FED_EPPN = "eppn";
    const FED_SPVI = "eduWisconsinSPVI";
    const FED_FULLNAME = "eduWisconsinCommonName";
    const FED_FIRST_NAME = "eduWisconsinGivenName";
    const FED_LAST_NAME = "eduWisconsinSurname";
    const FED_EMAIL = "eduWisconsinEmailAddress";

    // Generic and/or UWMSN constants
    const SHIB_SESSION_ID = 'Shib-Session-Id';
    const SHIB_SESSION_ID_HTTP = 'HTTP_SHIB_SESSION_ID';
    const UDDS = "udds";
    const SOURCE = "source";
    const ISIS_EMPLID = "isisEmplid";

    /**
     * Map Shibboleth header values to an associative array.
     *
     * @return UserDetails
     */
    public function loadUser();

}